'This example shows some basic function. 
'  When the connect button on the main panel is pressed, the DLL will search for, and then
'  connect to the first Model 30x device that it finds. I've also provided an example of basic
'  digital I/O. Please visit our website to view the entire API:
'       http://www.lawsonlabs.com/Download/Manuals-Drivers/Model_301_302/M30x_SP_X/Shared/ArchiveContents/_HTML_docs/FunctionUsage/FuncUse.htm
'  the same link condensed for easy copy:
'       http://tinyurl.com/62qp6a
'Using CTRL + "left mouse button" will load the page here for you.
'Links from the main page: http://www.lawsonlabs.com to the developer's section will provide additional
'  links for other software language examples as well as answers to some frequently asked questions and
'  other reference material.

Public Class Form1
    Inherits System.Windows.Forms.Form
    Public usDevID, sModelNum As Short, bRetVal As Byte
    Public myMsgs As TextBox
    Declare Function EX_Connect Lib "LL_USB2k.dll" (ByRef usDevID As Short) As Byte
    Declare Function EX_ReConnectOneDev Lib "LL_USB2k.dll" (ByVal usDevID As Short) As Byte
    Declare Function EX_SendDigout Lib "LL_USB2k.dll" (ByVal usDevID As Short, ByVal bDigOut As Byte) As Byte
    Declare Function EX_GetDigin Lib "LL_USB2k.dll" (ByVal usDevID As Short, ByRef usDevID As Byte) As Byte
    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        panelWait.Visible = True : panelWait.Location = New Point(3, 8) : panelWait.Update()
        Label2.Text = "Connecting" : Label2.Update()
        bRetVal = EX_Connect(usDevID)
        If bRetVal = 0 Then
            Msgs.Text = "Failed connecting" & vbCrLf
            txtDevID.Text = "" : btnDigout.Enabled = False : txtDigout.Enabled = False : btnDigIn.Enabled = False : txtDigIn.Enabled = False
        Else
            Msgs.Text = "Success connecting" & vbCrLf : If ((usDevID > 100) And (usDevID < 5000)) Then sModelNum = 301
            txtDevID.Text = usDevID : btnDigout.Enabled = True : txtDigout.Enabled = True : btnDigIn.Enabled = True : txtDigIn.Enabled = True
        End If
        panelWait.Visible = False
    End Sub
    Private Sub btnDigout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDigout.Click
        If txtDigout.Text = "" Then Exit Sub
        txtRet.Text = CByte(EX_SendDigout(usDevID, CByte(txtDigout.Text)))
    End Sub
    Private Sub btnDigIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDigIn.Click
        Dim bDigin As Byte
        txtRet.Text = CByte(EX_GetDigin(usDevID, bDigin))
        txtDigIn.Text = bDigin
    End Sub
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Form1.ActiveForm.Close()
    End Sub
    Private Function TrapKey(ByVal KCode As String) As Boolean
        If (KCode >= 48 And KCode <= 57) Or KCode = 8 Then : TrapKey = False
        Else : TrapKey = True : End If
    End Function
    Private Sub txtDigout_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtDigout.KeyPress
        e.Handled = TrapKey(Asc(e.KeyChar))
    End Sub
    Private Sub txtDigIn_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtDigIn.KeyPress
        e.Handled = TrapKey(Asc(e.KeyChar))
    End Sub
    Private Sub txtDigout_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDigout.TextChanged
        If txtDigout.Text > 255 Then txtDigout.Text = 255
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        usDevID = 0
    End Sub



End Class
